using System;
using System.Collections.Generic;
using System.Linq;
using Battlehub.RTSaveLoad.PersistentObjects;
using UnityEngine;
using UnityEngine.Serialization;

namespace CheesyFX
{
    public class CapsulePenetrator : Penetrator
    {
        private CapsuleCollider capsule;
        public bool isFucking;
        public Fuckable fuckable;

        public CapsulePenetrator Init(CapsuleCollider capsule)
        {
            base.Init(capsule);
            this.capsule = capsule;
            if (atom.type == "Dildo") RegisterDildo();
            if (capsule.name == "AutoColliderGen3bHard") RegisterPenis();
            SetTipAndWith();
            return this;
        }
        
        private void RegisterPenis()
        {
            type = 1;
            root = atom.rigidbodies.First(x => x.name == "Gen1");
            colliders = rootTransform.GetComponentsInChildren<Collider>(true).Where(x => !x.name.StartsWith("_")).ToList();
            rigidbodies = rootTransform.GetComponentsInChildren<Rigidbody>(true).ToList();
            colliders.ForEach(x => FillMeUp.penetratorByCollider[x] = this);
            // colliders.ForEach(x => x.transform.Draw());
            for (int i = 0; i < colliders.Count; i++)
            {
                var c = colliders[i];
                if (i < 2) forwardByCollider[c] = () => c.transform.up;
                else forwardByCollider[c] = () => c.transform.right;
            }
            forward = () => capsule.transform.right;
        }

        private void RegisterDildo()
        {
            type = 2;
            root = atom.rigidbodies.First(x => x.name == "b1");
            rootTransform = root.transform;
            colliders = rootTransform.GetComponentsInChildren<Collider>().Where(x => x.attachedRigidbody != null).ToList();
            // colliders.ForEach(x => x.transform.Draw());
            rigidbodies = rootTransform.GetComponentsInChildren<Rigidbody>(true).ToList();
            colliders.ForEach(x => FillMeUp.penetratorByCollider[x] = this);
            for (int i = 0; i < colliders.Count; i++)
            {
                var c = (CapsuleCollider)colliders[i];
                forwardByCollider[c] = () => c.transform.up;
            }
            forward = () => capsule.transform.up;
            atom.mainController.RBHoldPositionSpring = 1e5f;
        }

        public override void SetTipAndWith()
        {
            var scale = GetScale();
            // capsule.direction.Print();
            switch (capsule.direction)
            {
                case 0:
                    tip.localPosition = new Vector3(0f,capsule.radius * scale,0f);
                    width = capsule.height * scale*9f;
                    break;
                case 1:
                    tip.localPosition = new Vector3(0f,capsule.height * .5f * scale,0f);
                    width = 2f * capsule.radius * scale*9f;
                    break;
                case 2:
                    tip.localPosition = new Vector3(capsule.radius * scale, 0f, 0f);
                    width = capsule.height * scale*9f;
                    break;
            }
            if(type > 0) length = Vector3.Distance(tip.position, root.position);
            // $"{atom.name} {capsule.name} {width} {capsule.direction}".Print();
            // tip.Draw();
            // width.Print();
        }

        private void OnEnable()
        {
            SetTipAndWith();
            foreach (var orifice in FillMeUp.orifices)
            {
                if (orifice.penetrator == this) orifice.penetratorWidth = width;
            }
        }
    }
}