using UnityEngine;

namespace CheesyFX
{
    public class MeshPenetrator : Penetrator
    {
        public MeshCollider meshCollider;

        public MeshPenetrator Init(Collider meshCollider)
        {
            base.Init(meshCollider);
            this.meshCollider = (MeshCollider)meshCollider;
            return this;
        }

        public void SetTip()
        {
            tip.localPosition = Vector3.zero;
            width = .4f;
        }
    }
}