using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using Random = UnityEngine.Random;

namespace CheesyFX
{
    public class PoseForce : MonoBehaviour
    {
        private List<LimbForce> limbForces;
        private Vector3 force;
        private Vector3 torque;

        private Vector3 forceTarget;
        private Vector3 torqueTarget;
        
        private float quickness;

        public static float maxForceComponent = 100f;
        public static float maxTorqueComponent = 25f;
        private float maxQuickness = 1f;

        private float timer;

        public PoseForce Init()
        {
            limbForces = PoseMe.forceTargets.Select(x => new LimbForce(x)).ToList();
            enabled = false;
            return this;
        }

        private void FixedUpdate()
        {
            if (SuperController.singleton.freezeAnimation) return;
            for (int i = 0; i < limbForces.Count; i++)
            {
                limbForces[i].Update();
            }
        }

        // private void FixedUpdate()
        // {
        //     if (SuperController.singleton.freezeAnimation) return;
        //     timer -= Time.fixedDeltaTime;
        //     if (timer < 0f)
        //     {
        //         timer = Random.Range(1f, 10f);
        //         quickness = Random.Range(.2f, maxQuickness);
        //         forceTarget = new Vector3(
        //             Random.Range(-maxForceComponent, maxForceComponent),
        //             Random.Range(-maxForceComponent, maxForceComponent),
        //             Random.Range(-maxForceComponent, maxForceComponent));
        //         torqueTarget = new Vector3(
        //             2f*Random.Range(-maxTorqueComponent, maxTorqueComponent),
        //             Random.Range(-maxTorqueComponent, maxTorqueComponent),
        //             Random.Range(-maxTorqueComponent, maxTorqueComponent));
        //         
        //     }
        //     force = Vector3.Lerp(force, forceTarget, quickness*Time.fixedDeltaTime);
        //     torque = Vector3.Lerp(torque, torqueTarget, quickness*Time.fixedDeltaTime);
        //     for (int i = 0; i < PoseMe.forceTargets.Count; i++)
        //     {
        //         var target = PoseMe.forceTargets[i];
        //         target.AddForce(target.transform.TransformDirection(force));
        //         target.AddTorque(target.transform.TransformDirection(torque));
        //         
        //     }
        // }
    }
}