using System;
using UnityEngine;

namespace CheesyFX
{
    public class Torque : Force
    {
        public Torque Init(string name, Rigidbody rb, Func<Vector3> getDirection)
        {
            base.Init(name, rb, getDirection);
            enabled = false;
            return this;
        }
        
        protected override void AddForce()
        {
            rb.AddTorque(currentForce, ForceMode.Force);
        }
    }
}